<template lang='pug'>
BaseWebSite(title='Example Application' :version='version' :showThemeSwitcher='true'
    :showAbout='true' @toggle-about='$refs.about.toggle()')
  template(#root)
    BaseAbout(ref='about'
    title='Example Application'
    :contributors='$options.contributors' :components='$options.libs')
      | This is Base-Vue library playground site
  .container.h-100
    .row.justify-content-center
      .col-12.my-1
        Card.flex-grow-1(title='Example Application')
          li(key='0')
            | This application demonstrate some of the widgets provided by the
            | #[a(href='https://gitlab.cern.ch/apc/common/www/base-vue') base-vue] library.
          li(key='1')
            h5 Global Parameters
            .input-group
              .input-group-prepend
                span.input-group-text Animation Speed
              div.d-flex.flex-grow-1.border.px-1
                input.form-control-range(type='range' min='.01' max='1' step='.001' v-model='speed')
              .input-group-append
                span.input-group-text.text-monospace {{ (speed * 100).toFixed(1) + '%' }}

    // Note keep rows grouped by widget family
    .h3.mt-5 Markdown Widget
    hr
    .row.justify-content-center
      .col-12
        ExampleMarkdownWidget

    .h3.mt-5 SSVG Graphics
    hr
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleSSVG
      .col-12.col-lg-6.my-1
        ExampleSSVGIFrame

    .h3.mt-5 Data Sources
    hr
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleEventSource
      .col-12.col-lg-6.my-1
        ExampleInterval

    .h3.mt-5 Cards and Dialogs
    hr
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleCardSimple
      .col-12.col-lg-6.my-1
        ExampleCard
      .col-12.col-lg-6.my-1
        ExampleDialog

    .h3.mt-5 Inputs and Parameters
    hr
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleInput
      .col-12.col-lg-6.my-1
        ExampleInputError
      .col-12.col-lg-6.my-1
        ExampleParamInput
      .col-12.col-lg-6.my-1
        ExampleParamList
      .col-12.col-lg-6.my-1
        ExampleParamFile
      .col-12.col-lg-6.my-1
        ExampleParamError
      .col-12.col-lg-6.my-1
        ExampleParamReadonly
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleParamDate
      .col-12.col-lg-6.my-1
        ExampleParamToggle
      .col-12.col-lg-6.my-1
        ExampleBaseRadio
      .col-12.col-lg-6.my-1
        ExampleBaseParamLED

    .h3.mt-5 Animations and Utilities
    hr
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleAnimation
      .col-12.col-lg-6.my-1
        ExampleModalLoader
      .col-12.col-lg-6.my-1
        ExampleExpiryIcon
      .col-12.col-lg-6.my-1
        ExampleCollapsible
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleLogger
      .col-12.col-lg-6.my-1
        ExampleKeepFocusMixin
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleKeyboardEventMixin
      .col-12.col-lg-6.my-1
        ExampleGlobalKeyEvent
    .row.justify-content-center
      .col-12.col-lg-6.my-1
        ExampleRibbon
      .col-12.col-lg-6.my-1
        ExampleChangeReloadMixin

    .h3.mt-5 Filters
    hr
    .row.justify-content-center
      .col-12
        ExampleFilters

    .h3.mt-5 Charts
    hr
    .row.justify-content-center
      .col-12
        ExampleLineChart

    .row
      .col.b-bottom-pad
</template>
<script>

import {
  BaseAnimationBlock as AnimBlock,
  BaseAnimation,
  BaseCard as Card } from "../src";
import ExampleCard from "./AppExampleCard.vue";
import ExampleCardSimple from "./AppExampleCardSimple.vue";
import ExampleFilters from "./AppExampleFilters.vue";
import ExampleCollapsible from "./AppExampleCollapsible.vue";
import ExampleAnimation from "./AppExampleAnimation.vue";
import ExampleInput from "./AppExampleInput.vue";
import ExampleInputError from "./AppExampleInputError.vue";
import ExampleBaseParamLED from "./AppExampleParamLED.vue";
import ExampleParamDate from "./AppExampleParamDate.vue";
import ExampleParamInput from "./AppExampleParamInput.vue";
import ExampleParamFile from "./AppExampleParamFile.vue";
import ExampleParamReadonly from "./AppExampleParamReadonly.vue";
import ExampleParamList from "./AppExampleParamList.vue";
import ExampleParamError from "./AppExampleParamError.vue";
import ExampleGlobalKeyEvent from "./AppExampleGlobalKeyboardEvent.vue";
import ExampleKeyboardEventMixin from "./AppExampleKeyboardEventMixin.vue";
import ExampleChangeReloadMixin from "./AppExampleChangeReloadMixin.vue";
import ExampleKeepFocusMixin from "./AppExampleKeepFocusMixin.vue";
import ExampleModalLoader from "./AppExampleModalLoader.vue";
import ExampleDialog from "./AppExampleDialog.vue";
import ExampleMarkdownWidget from "./AppExampleMarkdownWidget.vue";
import ExampleRibbon from "./AppExampleRibbon.vue";
import ExampleExpiryIcon from "./AppExampleExpiryIcon.vue";
import ExampleParamToggle from "./AppExampleParamToggle.vue";
import ExampleBaseRadio from "./AppExampleBaseRadio.vue";
import ExampleLogger from "./AppExampleLogger.vue";
import ExampleSSVG from "./AppExampleSSVG.vue";
import ExampleSSVGIFrame from "./AppExampleSSVGIFrame.vue";
import ExampleEventSource from "./AppExampleEventSource.vue";
import ExampleInterval from "./AppExampleInterval.vue";
import ExampleLineChart from "./AppExampleLineChart.vue";

import contributors from "../Contributors.yml";
import components from "../Components.yml";

const options = {
  contributors, libs: components
};

export default {
  name: "App",
  ...options,
  components: {
    Card,
    AnimBlock,
    ExampleCard, ExampleCardSimple, ExampleFilters,
    ExampleCollapsible,
    ExampleAnimation, ExampleParamDate,
    ExampleParamInput, ExampleParamReadonly, ExampleParamFile,
    ExampleParamList, ExampleParamError, ExampleInput, ExampleInputError,
    ExampleBaseParamLED,
    ExampleKeepFocusMixin,
    ExampleKeyboardEventMixin, ExampleChangeReloadMixin, ExampleGlobalKeyEvent,
    ExampleModalLoader, ExampleMarkdownWidget, ExampleDialog,
    ExampleRibbon, ExampleExpiryIcon, ExampleParamToggle, ExampleBaseRadio,
    ExampleLogger, ExampleSSVG, ExampleSSVGIFrame, ExampleEventSource,
    ExampleInterval,
    ExampleLineChart
  },
  data() {
    return { speed: 1, version: VERSION };
  },
  watch: {
    speed() {
      BaseAnimation.animationSpeed = this.speed;
    }
  }

};

</script>
<style lang="scss">
.b-bottom-pad {
  min-height: 33vh;
}
</style>
